--[[----------------------------------------------------------------------------

NmbProfileDownloaderTask.lua

--------------------------------------------------------------------------------

ADOBE CONFIDENTIAL
------------------
Copyright 2018 Adobe Systems Incorporated
All Rights Reserved.

NOTICE: All information contained herein is, and remain the property of
Adobe Systems Incorporated and its suppliers, if any. The intellectual and
technical concepts contained herein are proprietary to Adobe Systems
Incorporated and its suppliers and may be covered by U.S. and Foreign
Patents, patents in process, and are protected by trade secret or copyright
law.  Dissemination of this information or reproduction of this material is
strictly forbidden unless prior written permission is obtained from
Adobe Systems Incorporated.

------------------------------------------------------------------------------]]

local Rx = require 'Rx'
local Observable = Rx.Observable

--------------------------------------------------------------------------------

local NmbProfileDownloaderTask = {

	_catalog = false,
	_styleSynchronizer = false,

}

--------------------------------------------------------------------------------
-- TODO [ashj 2018-08-24]: Check if we need to respect the sync paused
-- status. Right now, we are not, in this case.

function NmbProfileDownloaderTask:__init( catalog, styleSynchronizer )

	self._catalog = catalog
	self._styleSynchronizer = styleSynchronizer
	
end

--------------------------------------------------------------------------------

function NmbProfileDownloaderTask:close()

end

--------------------------------------------------------------------------------

function NmbProfileDownloaderTask:ensureCameraProfileExists( fileName, href )

	if not href then
		return Observable.just( true )
	end

	return self._styleSynchronizer:ensureCameraProfileExists( self._catalog:ozCatalogId(), href  )
	
end
--------------------------------------------------------------------------------

return Rx.Class 'NmbProfileDownloaderTask'( NmbProfileDownloaderTask )